label groupgame:
    "If you were going to use a group-based attack in battle, you would need to choose your element and subgroup size."
    menu:
        "Choose a group"
        "D_6 (Water)":
            $ g = 6
        "D_8 (Fire)":
            $ g = 8
        "D_10 (Earth)":
            $ g = 10
    menu:
        "Choose a subgroup size"
        "1":
            $ sg = 1
        "2":
            $ sg = 2
        "3" if g == 6:
            $ sg = 3
        "4" if g == 8:
            $ sg = 4
        "5" if g == 10:
            $ sg = 5
        "6" if g == 6:
            $ sg = 6
        "8" if g == 8:
            $ sg = 8
        "10" if g == 10:
            $ sg = 10
    $ movename = {
        6: {1: "Squirt", 2: "Water Shot", 3: "Water Wave", 6: "Hurricane"},
        8: {1: "Ember", 2: "Flame Shot", 4: "Heat Stroke", 8: "Wildfire"},
        10: {1: "Sand", 2: " Mudshot", 5: "Ground Shake", 10: "Earthshatter"}
    }[g][sg]
    $ sgm = 10*sg
    "The attack spell you chose is called [movename]. Since the subgroup size is [sg], it would cost [sgm] mana and it would do [sgm] damage."
    return

label witch1:

    # BEGIN DCHANGE
    $ witchid = "witch1"
    jump witch

    define nw = Character("[nameknown]", color="#228B22")
    # END DCHANGE

    label .shun:
        show nerdywitch
        $ traitor = witches[talked_to]["name"]
        "I saw you teaming up with [traitor]. So, please stop distracting me. I need to study for the tournament."
        return

    label .intro:
        play music "audio/unwrittenreturn.mp3" fadeout 1

        show nerdywitch

        menu:

            "Hi!":
                nw "Hello. Are you here for the tournament?"
                a "Yes. Well, also no. I'm from this kingdom. My wizard works in the castle. I didn't even know that there was a tournament until this morning."
                nw "I'm sorry. That must be rough. I've been preparing for this tournament for the last few months. I can't imagine what kind of stress you must be going through."
                a "Thanks. My wizard kind of just dropped me out here to fend for myself."
                nw "That's so awful. If you want to hang out before the tournament, consider me a friend."
                a "Thank you."
                nw "Don't mention it. Us apprentices have to stick together."


            "Woah! Are you a dragon?":
                nw "Woah! Are you a jerk?"
                a "I'm not a jerk. It's just a question."
                nw "How are you? Is a question. How would you feel if you were minding your own business and I went up to you and screamed, Hark! Are you a puny mortal?"
                a "I don't know. I don't like being called puny."
                nw "Well, I don't like being called a dragon."
                a "Why not? Dragons are cool."
                nw "Don't lie to me. Dragons are the bad guys in all bedtime stories. Nobody thinks we're cool."
                a "I do."
                nw "..."
                a "Hello? Are you okay?"
                nw "Sorry, it's just that nobody ever told me that I was cool before."
                a "Well, that's sad."
                nw "Yeah... Hey, I'm sorry for snapping at you before. I shouldn't have. I'm sorry. Can we start over?"
                a "Sure."

        nw "I'm Elizardbeth Galois."
        $ witches[witchid]["nameknown"] = name # DCHANGE
        $ nameknown = witches[witchid]["nameknown"] # DCHANGE

        a "I'm [pname]."

        nw "It's nice to meet you, [pname]."

        a "What kind of magic do you do?"

        nw "Elemental attacks."

        a "That's so cool!"

        nw "Thanks!"

        a "Can you teach me?"

        nw "You want me to teach you my best spells right before the wizard tournament? Was this your plan all along?"

        nw "Did you really think you could earn my trust by just talking to me?"

        a "..."

        nw "Alright, you won me over."

        a "Really?"

        nw "Sure. Why not? Knowledge exists to be shared. My wizard would be proud of me for teaching you."

        nw "Besides, I heard that the best way to commit material to memory is by teaching it to others. By teaching you, I'm really helping myself."

        a "Thank you... So, how do elemental attacks work?"

        $ books[bookid]["mentioned"] = True # DCHANGE
        $ persistent.books = books # DCHANGE
        nw "They pull their magic from {b}Group theory{/b}. There is a book in the library called \"[booktitle]\" that can tell you more about the specifics."

        nw "{b}Group theory{/b} gets a bad wrap for being one of the most challenging magical fields to study. The basic thing to understand is that for every group you learn, you gain a new elemental attack."

        show wizardpowerful

        nw "The amount of groups is bigger than all infinities. The greatest wizards study {b}Group theory{/b} to gain innumerable elemental attack and defense spells."

        hide wizardpowerful

        nw "The most powerful spells pull their magic from knowledge of how groups interact with each other."

        nw "{b}Group theory{/b} is about {b}subsets{/b}, {b}sets{/b}, and {b}groupings{/b}, but we don't have time for all of that. So, I'll teach you about {b}elements{/b}, which are the things contained within {b}sets{/b}."

        menu:
            nw "Are you still following me?"

            "Yes.":
                nw "Great."
                nw "I'll teach you one simple spell and then let you go read the book."

            "No.":
                nw "Oh. I'm sorry. You should go read \"[booktitle]\". It will state definitions clearly and explain concepts with pictures."
                nw "I'll try to go slower from here on out."
                nw "How about I teach you one simple spell and then let you go read the book?"
                nw "Does that sound okay?"
                menu:
                    "Yes.":
                        nw "Great."
                    "No.":
                        nw "Oh. Okay. You're free to go if you want to. I'd recommend taking a break and continuing. But the choice is up to you."
                        menu:
                            "I'll go back to the hall.":
                                jump hallway
                            "I'll pause, take a break, and come back.":
                                $ renpy.pause()
                                pass
        nw "Ready?"

        #insert picture of a triangle.

        show nerdywitch at slightright
        with move

        show onetriangle:
            yanchor 0.5
            yalign 0.65
            xalign 0.25
            zoom 2.5

        nw "We have one thing. It is a triangle."

        hide onetriangle

        show sixtriangles:
            yanchor 0.5
            yalign 0.65
            xalign 0.25

        # show poset red:
        #     yanchor 0.5
        #     yalign 0.5
        #     xalign 0.75
        #     zoom 2.0

        #insert picture of the 6 triangle actions

        nw "We have six actions we can do to this thing. We can flip it three ways and and rotate it two ways."

        nw "The action of doing nothing is also considered an action. The action of doing nothing is called the {b}identity{/b} element."

        #insert picture of all six things inside of a box

        hide sixtriangles

        show grouptriangle:
            yanchor 0.5
            yalign 0.65
            xalign 0.25

        nw "We can put these actions including the {b}identity{/b} into a group."

        nw "This group is called D₆."

        show waterdrop:
            #zoom 2.0

        nw "If you focus on the {b}group{/b} and all of the {b}elements{/b} within it, then you can cast a powerful water spell."

        nw "If you're interested, you can read the book, learn more groups, and add more elemental spells to your repertoire."

        nw "Then, you can come back here and we can hang out--I mean, I can help you practice casting some elemental spells."

        a "Sounds like a plan. I'll talk to you later."

        nw "See ya! Have fun!"
        # D₆ water
        # D₈ fire
        # D₁₀ earth

        # intro fun and magic easy conversation
        # math specialty
        # bye conversation easy

    #    "This is Witch 1, part 1. Go read Book 1."
        return

    label .not_read:
        show nerdywitch
        nw "Hey, did you like the book?"
        a "I haven't read it yet."
        nw "Really? Oh. Okay. I see."
        a "What?"
        nw "No, I get it. You don't like {b}Group theory{/b} or elemental spells."
        a "No, they're great. I just haven't gotten around to reading the book yet. Where is it again?"
        nw "It's in the library. If you read it and come back, then we can practice together before the tournament."
        a "Yeah, sounds good."
        nw "Great! I've never praciced with a friend before..."
        nw "Sorry, that was supposed to be in my head. I'll see you in a bit. Have fun!"
        a "You too!"
        return

    label .after_read:
        show nerdywitch
        nw "Hey, did you like the book?"
        a "The pentagons were cool."
        nw "Group D₁₀? Earth spells? Yeah, they're pretty cool."
        nw "Personally, I really like the rotating actions. They're so much easier for me to visualize than the transformations."
        a "You can visualize all of that stuff?"
        nw "Yeah. If I can keep the image crisp in my mind, then I can tap right into the magical power of {b}Group theory{/b} and cast elemental spells."
        #mana cost of spell is 10x size of subgroup
        return

    label .to_practice:
        show nerdywitch
        menu:
            nw "Do you want to practice the elemental attack spells from the reading?"

            "Yes!":
                return True

            "No":
                nw "Okay, let me know if you change your mind."
                return False

    label .practice:
        play music "audio/killingtime.mp3" fadeout 1

        show nerdywitch

        $ play_groupgame = True
        while play_groupgame:
            call groupgame from _call_groupgame
            menu:
                nw "Would you like to see another spell?"
                "Yes":
                    pass
                "No":
                    menu:
                        nw "Are you sure you want to leave practice?"

                        "Yes":
                            nw "Alright then. It was fun hanging out with you. We should do this again after the tournament."
                            $ play_groupgame = False

                        "Not yet.":
                            nw "Okay, then let's see another spell."

        # "this is Witch 1 practice."
        # "thanks for practicing, I'munna leave now bye."
        return

label book1:
    show bkg gt book 1
    $ renpy.pause()
    show bkg gt book 2
    $ renpy.pause()
    show bkg gt book 3
    $ renpy.pause()
    return
